/*******************************************************************************
 *                            C++ Verimag
 *    
 *
 *------------------------------------------------------------------------------
 * 	            Distributed and Complex Systems - Gires
 *------------------------------------------------------------------------------
 * real-time-clock.h
 *------------------------------------------------------------------------------
 *  Real-time clocks management for BIP2 Engine implementation
 *  + class RealTimeClock : global clock management
 *------------------------------------------------------------------------------
 * Created by Jacques COMBAZ on Tue Jun 02 2009
 *
 ******************************************************************************/

#ifndef LINUX_CLOCK_H
#define LINUX_CLOCK_H

#include "clock.h"


class LinuxClock;
class Scheduler;

/****************************************
 * Class: LinuxClock
 * Description:
 *
 *
 ****************************************/

class LinuxClock : public PlatformClock {
  /*** Protected data members ***/
  protected:
    BIP::Time mStart;
    Scheduler* mScheduler;

  /*** Constructors & Dectructors ***/
  public:
    LinuxClock(const char*  name);
    virtual ~LinuxClock();

  /*** Protected Utility Methods ***/
  protected:
    inline BIP::Time start() const                    { return mStart; }
    inline void      setStart(const BIP::Time& start) { mStart = start; }

    BIP::Time TIME() const;

  /*** Public Utility Methods ***/
  public:
    BIP::Time time() const;
    bool      wait(const BIP::Time&);
    void setup(Scheduler* sched) { mScheduler = sched; }
    void restart() { setStart(TIME()); }
};

#endif

