/*
 * Templated List-Node declaration
 */
template <class C>
class ListNode {
  private:
    C* m_obj;
    ListNode* m_next;

  public:
    ListNode(C*);
    ~ListNode();
    C* obj();
    ListNode<C>* next(); 
    void setNext(ListNode<C>*);
};

/*
 * Templated List-Node implemetation
 */
template <class C>
ListNode<C>::ListNode(C* obj) {
  m_obj = obj;
  m_next = NULL;
}

template <class C>
ListNode<C>::~ListNode() {
}

template <class C>
C* ListNode<C>::obj() {
  return m_obj;
}

template <class C>
ListNode<C>* ListNode<C>::next() {
  return m_next;
}

template <class C>
void ListNode<C>::setNext(ListNode<C>* c) {
  m_next = c;
}

/*
 * Templated Linked-List class declaration
 */

template <class C>
class LList {
  protected:
    ListNode<C>* head;
    ListNode<C>* current;
    
  public:
    LList();
    LList(C*);
    ~LList();
    C* popHead();
    C* popTail();
    void addHead(C*);
    void addTail(C*);
    void appendList(LList<C>*);
    bool empty();
};

/*
 * Templated Linked-List class implementation 
 */

template <class C>
LList<C>::LList() {
  head = current = NULL;
}

template <class C>
LList<C>::LList(C* c) {
  head = new ListNode<C>(c);
  current = new ListNode<C>(c);
}

template <class C>
LList<C>::~LList() {
  ListNode<C>* temp;
  while (head) {
    temp = head;
    head = head->next();
    delete temp;
  }
  head = NULL;
  current = NULL;
}

template <class C>
C* LList<C>::popHead() {
  ListNode<C>* temp = NULL;
  C* val = NULL;
  if (head) {
    temp = head;
    val = temp->obj();
    head = head->next();
    delete temp;
  }
  return val;
  //return temp? temp->obj():NULL;
}

template <class C>
C* LList<C>::popTail() {
}

template <class C>
void LList<C>::addHead(C* c) {
  ListNode<C>* temp = new ListNode<C>(c);
  temp->setNext(head);
  head = temp; 
}

template <class C>
void LList<C>::addTail(C* c) {
  ListNode<C>* temp = new ListNode<C>(c);
  if (!head) {
    head = temp;
  }
  else {
    ListNode<C>* t1 = head, *t2;
    while (t1 && (t2 = t1->next())) {
      t1 = t2;
    }
    t1->setNext(temp);
  }
}

template <class C>
bool LList<C>::empty() {
  return head ?  false : true;
}

template <class C>
void LList<C>::appendList(LList<C>* list) {
  while (!list->empty()) {
    this->addHead(list->popHead());
  }
}
