#ifndef STRUCTURE_H
#define STRUCTURE_H

#include <vector>
#include <cstdio>

typedef std::vector<bool> BitVector;

/*
 * Clock to measure performance 
 */

class BIP_Clock {
  private:
    double m_start, m_stop;
    double m_duration, m_limit;

  public:
    BIP_Clock();
    ~BIP_Clock();
    void start();
    void stop();
    inline double duration() const { return m_duration; }
    inline double limit() const { return m_limit; }
    inline void setLimit(double lim) { m_limit = lim; }
    inline void reset() { m_duration = 0; }
};

#endif

