#include <stdio.h>
#include <string.h>

#include "periodic6.h"

// initialization function
void periodic6_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void periodic6_fire(DOLCProcess *p, int mode) {

	switch (mode) {

	case MODE_NORMAL: {
		PHASE("mode_normal");

		// Read data from data channel
		DOLCDataVar(int, readData);
		DOLC_read((void*) PORT_IN, &(readData), 1, p);

		if (readData.valid) {
			printf("Periodic 6: Activated with index %d, read data: %d\n", p->local->index, *((int *)readData.ptr));
			fflush(stdout);
		} else {
			printf("Periodic 6: Activated with index %d, no new data available\n",	p->local->index);
			fflush(stdout);
		}

		break;
	}

	default:
		break;
	}

	p->local->index++;

	return;
}

// finish function
void periodic6_terminate(DOLCProcess *p) {
	fflush(stdout);
}
