#include <stdio.h>
#include <string.h>

#include "periodic1.h"

// initialization function
void periodic1_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void periodic1_fire(DOLCProcess *p, int mode) {
   DOLCDataVar(int, writeData);
   int r;

	switch (mode) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
		
		// Write p->local->index to data channel
		writeData.valid = true;
		*((int *)writeData.ptr) = p->local->index;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);

		if (!r) {
			printf("Periodic 1: Activated with index %d, sent data %d\n", p->local->index, *((int *)writeData.ptr));
			fflush(stdout);
		} else {
			printf("Periodic 1: Activated with index %d, write not successful\n", p->local->index);
			fflush(stdout);
		}

		break;
	

	default:
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void aperiodic1_terminate(DOLCProcess *p) {
	fflush(stdout);
}
