#include <string.h>

#include "aperprod.h"

// a BIP hack to see the aperiodic protocol state
//#include "aperprod_proto.h"
//Caperprod_State* protocolState() {
//    extern Caperprod_State 	 bip_Caperprod_state;  
//    return &bip_Caperprod_state;
//}

// initialization function
void aperprod_init(DOLCProcess *p) {
	p->local->index = 0;
	p->local->modeOfPeriodic2 = 1;
}

// fire function
void aperprod_fire(DOLCProcess *p, int modeProd) {
    DOLCDataVar(int, writeData);
    int r;
    int write_success = 0;
	switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
		// Write delta + p->local->index to data channel
		writeData.valid = true;
		dolcdata_writeData = 123000000 + p->local->index;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);

		if (r==write_success) {
			printf("Producer: INFO   Activated with index %d send data %d\n", p->local->index, dolcdata_writeData);
//			printf("Producer: INFO   Activated with index %d controller state %d\n", p->local->index, protocolState()->count); // BIP hack
			fflush(stdout);
		} else {
			printf("Producer: ERROR Activated with index %d,  WRITE FAILED (mailbox full?)\n", p->local->index);
			fflush(stdout);
		}

		writeData.valid = true;
		dolcdata_writeData = 878787878;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);
        if (r==write_success) {
		    writeData.valid = false;
    		dolcdata_writeData = 999999999;
		    r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);
            if (r==write_success) {
                printf("Producer: INFO   Activated with index %d written and erased garbage data\n", p->local->index);
                fflush(stdout);
            } else {
                printf("Producer: ERROR Activated with index %d, GARBAGE ERASE FAILED (really weird!)\n", p->local->index);
                fflush(stdout);
            }
        }

       break;

	default:
		printf("Producer: ERROR Activated with index %d, MODE DEGRADED???\n", p->local->index);
		fflush(stdout);
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void aperprod_terminate(DOLCProcess *p) {
	fflush(stdout);
}
