#include <string.h>

#include "periodic1.h"

// initialization function
void periodic1_init(DOLCProcess *p) {
	p->local->index = 0;
	p->local->modeOfPeriodic2 = 1;
}

// fire function
void periodic1_fire(DOLCProcess *p, int modeProd) {
    DOLCDataVar(int, writeData);
    int r;
	switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
		// Write p->local->index to data channel
		writeData.valid = true;
		dolcdata_writeData = p->local->index;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);

		if (!r) {
			printf("Periodic 1: Activated with index %d, send data %d\n", p->local->index, dolcdata_writeData);
			fflush(stdout);
		} else {
			printf("Periodic 1: Activated with index %d, write not successful\n", p->local->index);
			fflush(stdout);
		}

		// Change the mode of periodic 2
//		if (p->local->index % 5 == 4) {
//			p->local->modeOfPeriodic2 = p->local->modeOfPeriodic2 == 0 ? 1 : 0;
//			DOLC_send_event((void*) PORT_EVENT_PERIODIC2, &(p->local->modeOfPeriodic2), p);
//		}
	 
       break;

	default:
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void periodic1_terminate(DOLCProcess *p) {
	fflush(stdout);
}
