#include <stdio.h>
#include <string.h>

#include "producer.h"

void producer_init(DOLCProcess *p) {
    p->local->index = 0;
    p->local->len = LENGTH;
    p->local->skip = 0;
}


int producer_fire(DOLCProcess *p, int mode) {

    int result;
    DOLCDataVar( float, myOutput);
    
    if (p->local->index < p->local->len && p->local->skip==0) {
        if (p->local->index%6==4) {
            myOutput.valid = false;
            printf("[Producer] Write INVALID\n");
        } else {
            myOutput.valid = true;
            dolcdata_myOutput = (float) p->local->index;
            printf("[Producer] Write: %f \n", dolcdata_myOutput);
        }
        result = DOLC_write((void*)PORT_OUT, &myOutput, 1, p);
        if (result!=0) {
            printf("Hey! Cannot write to buffer! Maybe it is a mailbox and it is full?\n");
        }
        p->local->index++;
    } else {
        if (p->local->index < p->local->len) printf("[Producer] Skip\n");
    }

    if (p->local->skip==0) { p->local->skip = p->local->index%5; }
    else {p->local->skip--;}
    
    if (p->local->index >= p->local->len) {
        return 1; // terminate
    }

    return 0;
}


