#include <stdio.h>
#include <string.h>

#include "periodic5.h"

// initialization function
void periodic5_init(DOLCProcess *p) {
	p->local->index = 0;
}

typedef int ReadType[2];

// fire function
void periodic5_fire(DOLCProcess *p, int mode) {
    int counterChan = 0;
	DOLCDataVar(int, writeData);
    int r;
   char buf[1001];
   const int sz = 1000;

   
		// Read data from data channels
		DOLCDataVar(ReadType, readData1);
		DOLCDataVar(ReadType, readData2);
		DOLCDataVar(ReadType, readData3);
		DOLCDataVar(ReadType, readData4);

	switch (mode) {

	case MODE_NORMAL: 
		PHASE("mode_normal");

		
		DOLC_read((void*) PORT_IN1, &(readData1), 1, p);
		if (readData1.valid) {
			printf("Periodic 5(%s): Activated with index %d, read data from periodic1: %d\n", thread_info(buf,sz),p->local->index, *((int *)readData1.ptr));
			fflush(stdout);
			counterChan++;
		} else {
			printf("Periodic 5(%s): Activated with index %d, no new data available from periodic1\n",	thread_info(buf,sz),p->local->index);
			fflush(stdout);
		}
		DOLC_read((void*) PORT_IN2, &(readData2), 1, p);
		if (readData2.valid) {
			printf("Periodic 5(%s): Activated with index %d, read data from periodic2: %d\n", thread_info(buf,sz),p->local->index, *((int *)readData2.ptr));
			fflush(stdout);
			counterChan++;
		} else {
			printf("Periodic 5(%s): Activated with index %d, no new data available from periodic2\n",	thread_info(buf,sz),p->local->index);
			fflush(stdout);
		}
		DOLC_read((void*) PORT_IN3, &(readData3), 1, p);
		if (readData3.valid) {
			printf("Periodic 5(%s): Activated with index %d, read data from periodic3: %d\n", thread_info(buf,sz),p->local->index, *((int *)readData3.ptr));
			fflush(stdout);
			counterChan++;
		} else {
			printf("Periodic 5(%s): Activated with index %d, no new data available from periodic1\n",	thread_info(buf,sz),p->local->index);
			fflush(stdout);
		}
		DOLC_read((void*) PORT_IN4, &(readData4), 1, p);
		if (readData4.valid) {
			printf("Periodic 5(%s): Activated with index %d, read data from periodic4: %d\n", thread_info(buf,sz),p->local->index, *((int *)readData4.ptr));
			fflush(stdout);
			counterChan++;
		} else {
			printf("Periodic 5(%s): Activated with index %d, no new data available from periodic4\n",	thread_info(buf,sz),p->local->index);
			fflush(stdout);
		}
		
		// Write number of received data to blackboard Sensors
		writeData.valid = true;
		*((int *)writeData.ptr) = counterChan;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);
		if (!r) {
			printf("Periodic 5: Activated with index %d, sent data %d\n", p->local->index, *((int *)writeData.ptr));
			fflush(stdout);
		} else {
			printf("Periodic 5: Activated with index %d, write not successful\n", p->local->index);
			fflush(stdout);
		}

		break;

	default:
		break;
	}

	p->local->index++;

	return;
}

// finish function
void periodic5_terminate(DOLCProcess *p) {
	fflush(stdout);
}
