#include "global.h"

#include <pthread.h>
#ifdef __K1__
#include <HAL/hal/hal.h>
#endif 

#include <cstring>
#include <string>
#include <sstream>

using namespace std;

static int loop_a = 0;

void execute_loop_for_msec(long duration) {
//  Does not work on Kalray MPPA:
//    clock_t endcl = ::clock() + (duration*CLOCKS_PER_SEC)/1000;
//    while ( ::clock() < endcl) {
//        int k;
//        for (k=0; k<1000; k++) { loop_a = k + 1;}            
//    }            

   struct timeval starttim;
   gettimeofday(&starttim, NULL);
 
   while (true) {
     int k;
     for (k=0; k<1000; k++) { loop_a = k + 1;}
     struct timeval endtim;
     gettimeofday(&endtim, NULL);
     long diff_sec  = endtim.tv_sec  - starttim.tv_sec;
     long diff_usec = endtim.tv_usec - starttim.tv_usec;
 
     long diff_msec = diff_sec*1000 + diff_usec/1000;
     if (diff_msec>=duration) break;
   }
}

const char* thread_info(char* buf, int sz) {
    stringstream infostr;
#ifdef __K1__
    infostr << "thread: " << pthread_self() << "; cluster: " <<  __k1_get_cluster_id() << "; core: " << __k1_get_cpu_id(); 
#else
    infostr << "thread: " << pthread_self();
#endif
    strncpy(buf, infostr.str().c_str(),sz);
    return buf;
}

